/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/
#ifndef __DEBUG_LOGGER_H
#define __DEBUG_LOGGER_H

#include "system.timestamp.h"
#include "io.outputstream.h"
#include "io.file.h"

namespace magnum { namespace debug {
using magnum::object::Object;
using magnum::types::String;
using magnum::system::Timestamp;
using magnum::io::File;
using magnum::io::OutputStream;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Logger : public Object {
DeclareClass(Logger, Object);
private:
	OutputStream*		m_Stream;
	File*				m_File;
	Timestamp			m_Timestamp;
	
public:
	Logger(OutputStream* );
	Logger(File* );
	Logger(const char* );
	Logger(const Logger& );
	~Logger();
	
	inline OutputStream*	getStream() const;
	
	void					writeLine(const String& );
	void					writeLine(const char* );
};

inline Logger& operator<<(Logger& ,const char* str);
inline Logger& operator<<(Logger& ,const String& str);

}; };

#endif
