/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GEOMETRY_NORMALIZER_H
#define __GEOMETRY_NORMALIZER_H

#include "object.h"
#include "math.vector.h"

namespace magnum { namespace geometry {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T,class I> Normalizer : public Object {
DeclareClass(Normalizer, Object);
private:
	const Vector3<T>*	m_Vertices;
	unsigned int		m_VertexStride;
	unsigned int		m_VertexCount;
	Vector3<T>*			m_Normals;
	unsigned int		m_NormalStride;
	const I*			m_Indices;
	unsigned int		m_Size;

public:
	inline unsigned int getVertexStride() const;
	inline const Vector3<T>* getVertices() const;
	inline void			setVertices(const Vector3<T>* ,unsigned int = sizeof(Vector3<T>));

	inline unsigned int getNormalStride() const;
	inline const Vector3<T>* getNormals() const;
	inline void			setNormals(const Vector3<T>* ,unsigned int = sizeof(Vector3<T>));
	
	inline const I*		getIndices() const;
	inline void			setIndices(const I* ,unsigned int );
	
	void				normalizeTriangleList();
	void				normalizeTriangleStrip();
};

}; };

#endif
