/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_FIXEDSHADER_H
#define __GRAPHICS3D_FIXEDSHADER_H

#include "graphics3d.shader.h"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FixedShader : public Shader {
DeclareClass(FixedShader, Shader);
public:
	enum Features {
		Plain = 0,
		Lighting = 1,
		TwoSided = 2,
		LocalViewer = 4,
		
		DefaultFeatures = 7
	};
	
private:
	unsigned int		m_Features;
	
protected:
	inline				FixedShader(Features = DefaultFeatures);
	
public:
	inline unsigned int	getFeatures() const;
	
protected:
	virtual void		onSelect() const;
	virtual void		onDeselect() const;

	virtual void		onCompileSelect(Assembler& ) const;
	virtual void		onCompileDeselect(Assembler& ) const;
};


}; };

#endif
