/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_CONTENT_H
#define __IO_CONTENT_H

#include "object.h"

namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;
using magnum::types::byte;
using magnum::types::word;
using magnum::types::dword;

class File;
class InputStream;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Content : public Object {
DeclareClass(Content, Object);
private:
	byte*			m_Buffer;
	unsigned int	m_Size;
	
public:
	inline Content(File* );
	inline Content(InputStream* );
	inline Content(InputStream& );
	~Content();
	
	inline				operator const char*() const;
	
	inline unsigned int	getSize() const;
	
	inline const char*	toChars() const;
	inline const byte*	toBytes() const;
	inline const word*	toWords() const;
	inline const dword*	toDword() const;
	inline const float*	toFloats() const;
	inline const double* toDoubles() const;
	
private:
	void				readBuffer(InputStream* );
};

}; };

#endif
