/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_DATAINPUT_H
#define __IO_DATAINPUT_H

#include "object.h"

namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::byte;
using magnum::types::word;
using magnum::types::dword;
using magnum::types::String;

class InputStream;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class DataInput : public Object {
DeclareClass(DataInput, Object);
private:
	InputStream*		m_Input;
	unsigned long		m_BytesRead;

public:
	explicit inline DataInput(InputStream* );
	explicit inline DataInput(InputStream& );
	inline ~DataInput();
	
	inline unsigned long getBytesRead() const;
	
	inline void			skip(unsigned long );
	inline unsigned long read(void *buffer, unsigned long size);
	inline unsigned long available();
	inline void			close();

	inline bool			readBoolean();
	inline float		readFloat();
	inline double		readDouble();
	inline char			readChar();
	inline byte			readByte();
	inline word			readWord();
	inline dword		readDword();

	String				readLine();
};

}; };

#endif
