/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_DATAOUTPUT_H
#define __IO_DATAOUTPUT_H

#include "object.h"

namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::byte;
using magnum::types::word;
using magnum::types::dword;
using magnum::types::String;

class OutputStream;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class DataOutput : public Object {
DeclareClass(DataOutput, Object);
private:
	OutputStream*		m_Output;
	unsigned long		m_BytesWritten;

public:
	explicit inline DataOutput(OutputStream* );
	explicit inline DataOutput(OutputStream& );
	inline ~DataOutput();
	
	inline unsigned long getBytesWritten() const;
	
	inline unsigned long write(const void *buffer, unsigned long size);
	inline void			flush();
	inline void			close();

	inline void			writeBoolean(bool );
	inline void			writeFloat(float );
	inline void			writeDouble(double );
	inline void			writeChar(char );
	inline void			writeByte(byte );
	inline void			writeWord(word );
	inline void			writeDword(dword );

	inline void			writeLine(const String& );
};

}; };

#endif
