/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_FILESTREAM_H
#define __IO_FILESTREAM_H

#include "io.inputstream.h"
#include "io.outputstream.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;

class File;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FileInputStream : public InputStream {
DeclareClass(FileInputStream, InputStream);
private:
	File*					m_File;

public:
	explicit FileInputStream(File* );
	~FileInputStream();

protected:
	inline unsigned long 	onRead(void *buffer, unsigned long  size);
	inline unsigned long 	onSkip(unsigned long  size);
	inline unsigned long 	onAvailable();
	bool					onClose();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FileOutputStream : public OutputStream {
DeclareClass(FileOutputStream, OutputStream);
private:
	File*	m_File;

public:
	explicit FileOutputStream(File* );
	~FileOutputStream();

protected:
	inline unsigned long	onWrite(const void *buffer, unsigned long size);
	inline bool				onFlush();
	bool					onClose();
};

}; };

#endif
