/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_FILESTREAM_INL
#define __IO_FILESTREAM_INL

namespace magnum { namespace io {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long FileInputStream::onRead(void *buffer, unsigned long size) {
	return m_File->read(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long FileInputStream::onSkip(unsigned long size) {
	unsigned long pos = m_File->getPosition();
	m_File->setPosition(size, File::Current);
	return m_File->getPosition() - pos;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long FileInputStream::onAvailable() {
	return m_File->getSize() - m_File->getPosition();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long FileOutputStream::onWrite(const void *buffer, unsigned long size) {
	return m_File->write(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	FileOutputStream::onFlush() {
	return m_File->flush();
}

}; };

#endif

