/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_INPUTSTREAM_H
#define __IO_INPUTSTREAM_H

#include "io.stream.h"
#include "base.string.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class InputStream : public Stream {
DeclareClass(InputStream, Stream);
protected:
	inline InputStream();
	
public:
	inline unsigned long	read(void *buffer, unsigned long size);
	inline unsigned long	skip(unsigned long size);
	inline unsigned long	available();
	inline bool				close();

protected:
	virtual unsigned long 	onRead(void *buffer, unsigned long size) = 0;
	virtual unsigned long 	onSkip(unsigned long size) = 0;
	virtual unsigned long 	onAvailable() = 0;
	virtual bool			onClose() = 0;
};


InputStream& operator>>(InputStream&, String& str);
InputStream* operator>>(InputStream*, String& str);

}; };

#endif
