/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __NET_SOCKETSTREAM_H
#define __NET_SOCKETSTREAM_H

#include "io.inputstream.h"
#include "io.outputstream.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::InputStream;
using magnum::io::OutputStream;

class Socket;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SocketInputStream : public InputStream {
DeclareClass(SocketInputStream, InputStream);
private:
	Socket*	m_Socket;
	
public:
	SocketInputStream(Socket* );
	~SocketInputStream();

protected:
	unsigned long onRead(void *buffer, unsigned long size);
	unsigned long onSkip(unsigned long size);
	unsigned long onAvailable();
	inline bool	onClose();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SocketOutputStream : public OutputStream {
DeclareClass(SocketOutputStream, OutputStream);
private:
	Socket*	m_Socket;

public:
	SocketOutputStream(Socket* );
	~SocketOutputStream();

protected:
	unsigned long onWrite(const void *buffer, unsigned long size);
	bool		onFlush();
	inline bool	onClose();
};

}; };

#endif
