/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "system.h"

#include "base.string.inl"
#include "object.class.inl"
#include "object.inl"
#include "system.inl"
#include "io.stream.inl"
#include "io.inputstream.inl"
#include "io.outputstream.inl"

#include <stdio.h>

namespace magnum { namespace system {

System::StandardInputStream System::In;
System::StandardOutputStream System::Out;
System::StandardErrorStream System::Err;

#if defined(__FORWINDOWS__)
HINSTANCE System::WindowInstance;
#endif


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned long System::StandardInputStream::onRead(void *buffer, unsigned long size) {
	if (fread(buffer, size, 1, stdin) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned long System::StandardInputStream::onSkip(unsigned long size) {
	if (fseek(stdin,size,SEEK_CUR) != 0)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned long System::StandardInputStream::onAvailable() {
	return 1;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool System::StandardInputStream::onClose() {
	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned long System::StandardOutputStream::onWrite(const void *buffer, unsigned long size) {
	if (fwrite(buffer, size, 1, stdout) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool System::StandardOutputStream::onFlush() {
	fflush(stdout);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool System::StandardOutputStream::onClose() {
	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
unsigned long System::StandardErrorStream::onWrite(const void *buffer, unsigned long size) {
	if (fwrite(buffer, size, 1, stderr) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool System::StandardErrorStream::onFlush() {
	fflush(stderr);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool System::StandardErrorStream::onClose() {
	return false;
}

}; };
